/*
 * Written by Sebastian Tilders
 * Licensed under the GPL (General Public License)
 * Project name: InfoOS
 */
#ifndef _GDT_H
#define _GDT_H
#include "typedefs.h"

#define GDT_ENTRIES 6
#define IDT_ENTRIES 254
#define IDT_TASK_GATE 0x5
#define IDT_INT_GATE 0x6
#define IDT_TRAP_GATE 0x7
struct task_state_segment
{
  uint32_t previous_task_link;
  uint32_t esp0;
  uint32_t ss0;
  uint32_t esp1;
  uint32_t ss1;
  uint32_t esp2;
  uint32_t ss2;
  uint32_t cr3;
  uint32_t eip;
  uint32_t eflags;
  uint32_t eax;
  uint32_t ecx;
  uint32_t edx;
  uint32_t ebx;
  uint32_t esp;
  uint32_t ebp;
  uint32_t esi;
  uint32_t edi;
  uint32_t es;
  uint32_t cs;
  uint32_t ss;
  uint32_t ds;
  uint32_t fs;
  uint32_t gs;
  uint32_t ldt_segment_selector;
  uint32_t io_map_base_adress;
};
void setup_idt(void);
void setup_gdt(void);
void setup_pic(void);
// Hilfsfunktionien
#endif
