/*
 * Written by Sebastian Tilders
 * Licensed under the GPL (General Public License)
 * Projekt-Name: InfoOS
 */
#include "../header/typedefs.h"
#include "../header/display.h"
#include "../header/string.h"
#include "../header/gdt.h"
#include "../header/timer.h"
#include "../header/task.h"
#include "../header/pmm.h"
uint16_t create_task(uint8_t* process, uint16_t ring);
void init_multi(struct multiboot* mbs_info);
// INIT Kernel
void test_multi(void)
{
print("A Userspace task is running!\r\n",DSP_COLOR_GRAY);
while(1) { }
}
void test3_multi(void) { print("A ring 0 task is running!\r\n", DSP_COLOR_GRAY); while(1); }
void multi_init(void)
{
print("Free Memory: ", DSP_COLOR_BLUE);
print(int2ascii(free_memory()/0x100000),DSP_COLOR_GREEN);
print(" MB\n\r", DSP_COLOR_GREEN);
while(1)  { }
}
void loaded_mods(struct multiboot* mb_header) { print("Geladene Kernel Module: ",DSP_COLOR_GRAY); print(int2ascii(mb_header->mbs_mods_count),DSP_COLOR_GREEN); print("\r\n",DSP_COLOR_GRAY); }
void init(struct multiboot* mb_header)
{
cls();
print("Welcome to ",DSP_COLOR_WHITE);
print("Infortus - LiveCD\n\r",DSP_COLOR_LIGHTBLUE);
print("Bootstrapping - PHASE 1 of 3\n\r", DSP_COLOR_LIGHTGREEN);
print("-------------------------\n\rWritten by Informatikonline.net\r\n",DSP_COLOR_WHITE);
print("Writing GDT entries...", DSP_COLOR_GRAY);
setup_gdt();
print_right("[Done]");
print("Writing IDT entries...", DSP_COLOR_GRAY);
// IDT Einträge festlegen IRQ 1 - 15	
setup_idt();
print_right("[Done]");
print("Programming the PIC...", DSP_COLOR_GRAY);
setup_pic();
print_right("[Done]");
print("INIT Physical Memory Managment...",DSP_COLOR_GRAY);
pmm_init(mb_header);
print_right("[Done]");
print("INIT Multitasking...",DSP_COLOR_GRAY);
init_multi(mb_header);
print_right("[Done]");
asm volatile("cli");
loaded_mods(mb_header);
create_task((uint8_t*) &test_multi,3);
create_task((uint8_t*) &test3_multi,0);
create_task((uint8_t*) &multi_init,0);
asm volatile("sti");
return;
}
