/*
 * Written by Sebastian Tilders
 * Licensed under the GPL (General Public Licsense)
 * Project Name: InfoOS
 */
#include "../header/string.h"
#include "../header/typedefs.h"
// Bildschirmdefinition
#define DISPLAY_MEM_START 0xb8000
#define DISPLAY_MEM_END 0xB8FA0
#define DISPLAY_MEM_SIZE (DISPLAY_MEM_END - DISPLAY_MEM_START)
// Konsolendefinition
#define LINE (console_y * 0xA0)

// Video-Speicher Zeiger & cursor Koordinaten
int console_y = 0;
int console_x = 0;
char* video = (char*) 0xb8000;

/* Bildschirm Scrollen */
inline void scroll(void)
{
	console_y--;
	console_x = 0;
	memcpy((char*)DISPLAY_MEM_START,(char*)(DISPLAY_MEM_START+0xA0),DISPLAY_MEM_SIZE - 0xA0);
	memset((char*)(DISPLAY_MEM_END - 0xA0),(char)0,0xA0);
}

// Bildschirm löschen
void cls(void)
{
	for(video=(char*)DISPLAY_MEM_START; video < (char*) DISPLAY_MEM_END;video++)
		*video=0;
		video = (char*) 0xb8000;
	console_x = 0;
	console_y = 0;
	return;
}

// Einzelne Zeile ausgeben (Farbe 0x7)
void s_line_print(char text[])
{
	int cursor = 0;
	for(cursor = 0; cursor < strlng(text);cursor++)
	{
		if(console_x > 80)
		{
			console_y++;
			console_x = 0;
		}
		if(console_y >= 25) scroll();
		video[LINE+(2*cursor)] = text[cursor];
		video[LINE+(2*cursor)+1] = 0x7;
	}
	console_y++;
	return;
}

// Einzelnes Zeichen ausgeben
void put_char(char c, int color)
{
	switch(c) {
	case '\r':
		console_x = 0;
	break;
	case '\n':
		console_y++;
	break;
	default:
		if (console_x >= 80)
		{
		console_y++;
		console_x = 0;
		}
		if(console_y >= 25)
		{
			scroll();
		}
		video[LINE + console_x*2] = c;
		video[LINE + (console_x * 2) + 1] = color;
		console_x++;
	break;
	}
}

/*
 * Zeichenkette ausgeben ; Color wird als hexadezimalwert angegeben
 *  bsp: 0x07 (Grau)
 */
void print(char text[],int color)
{
	int count;
	for(count = 0; count < strlng(text);count++)
	{
	put_char((char) text[count],(int) color);
	}
}

// Eine Integer Zahl nach Hexadezimal Ascii konvertieren
char* int2hex_ascii(uint32_t z)
{
char buffer[25];
buffer[0] = 0;
static char buffer2[25] = "0x";
if(z <= 0)
{
return "0x0";
}
else
{
char c;
int length = 0;
while(z) { c = z % 16; if (c > 9) { c += 7; } c += 48; z /= 16; buffer[length++] = c;}
reverse_string(buffer);
int i;
for(i=0;i <= strlng(buffer); i++)
{
	buffer2[i+2] = buffer[i];
}
return buffer2;
}
}

// Eine Integer Zahl nach Ascii konvertieren
char* int2ascii(uint32_t z)
{
uint8_t i;
static char buffer[25];
for(i=0;i<25;i++)
{
	buffer[i] = 0;
}
if(z <= 0)
{
return "0";
}
else
{
char c;
int length = 0;
while(z) {c = (z % (uint32_t)10); c += '0';  z /= (uint32_t)10; buffer[length++] = c;}
reverse_string(buffer);
return buffer;
}
}
void print_right(char text[])
{
uint8_t len = strlng(text);
console_x = 79 - len;
print(text,0x2);
console_x++;
}
