/* $Id$
 * Written by Sebastian Tilders
 * Licensed under the GPL (General Public License)
 * Project Name: InfoOS
 */
#include "../header/interrupts.h"
#include "../header/gdt.h"
#define PRINT_LINE 0
#define PRINT_CHAR 1
struct cpu_state* schedule(struct cpu_state* cpu);
extern struct task_state_segment tss;
struct cpu_state* handle_interrupt(struct cpu_state* cpu)
{
if(cpu->intr == 0x30)
{
	switch(cpu->eax)  {
	case PRINT_LINE:
		print((char*) cpu->ebx,DSP_COLOR_GRAY);
	break; }
}
if(cpu->intr <= 0x1f)		// wenn kleiner als 31 ist es eine Exeception
{
	print("Exception: ",DSP_COLOR_RED);
	print(int2ascii(cpu->intr), DSP_COLOR_RED);
	print(" \n\rKernel Angehalten!", DSP_COLOR_RED);
	while(1)
	{
		asm volatile("cli;hlt");
	}
	// return 0;
}
else			// Andernfalls Schedulen
{
tss.ss0 = 0x10;
struct cpu_state* new_cpu = cpu;
if(cpu->intr == 0x20)
{
new_cpu = schedule(cpu);
tss.esp0 = (unsigned long) (new_cpu + 1);
}
// Bei Hardware Interrupts EOI senden.
if (cpu->intr >= 0x20 && cpu->intr <= 0x2f) {
    if (cpu->intr >= 0x28) {
        outb(0xa0, 0x20);
    }
    outb(0x20, 0x20);
}
return new_cpu;
}
}
