; Written by Sebastian Tilders
; Licensed under the GPL (General Public License)
; Project name: InfoOS
global loader
global load_selectors
MB_MAGIC equ 0x1badb002
MB_FLAGS equ 0x3
MB_CHECKSUM equ - (MB_MAGIC + MB_FLAGS)
section multiboot
; Multiboot Header
align 4		; Durch 4 teilbare Adressen
dd MB_MAGIC
dd MB_FLAGS
dd MB_CHECKSUM

section .text
extern init			; Init ist extern (C-Code)

loader:
mov esp, 0x200000	; Stack bei 2 MiB
push ebx			; Multiboot Struktur

call init			; Kernel initalisieren
kernel_end:
hlt					; Prozessor anhalten
jmp kernel_end
; Selektoren laden
load_selectors:
mov ax,0x10			; Selektor 0x10 nach ax
mov ds,ax			; Datensegment updaten
mov es,ax			; Extra-Segement updaten 
mov ss,ax			; Stack-Segment updaten
jmp 0x8:continue	; Selektor 0x8 nach CS laden und EIP erhöhen (far-jump)
continue:
ret					; Zu Init zurückkerhen (s. C-Code)
